<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: tools/control/control.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: tools/control/control.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>/**
* Allows to control basic funcitonalities of plaiframe.
* start and cancel sessions, triggger next cues etc.
*
* @requires tool
* @requires medley
*
* @module control
*/

const tool = require("../tool.js")
const schema = require('./schema.json')
const medley = require('./../../medley.js')

class SessionControl extends tool.Tool {
  constructor() {
    super()
  }
  
  setup(config) {
    super.setup(config)
    return schema
  }
  
  cue(data, session) {
    return new Promise((resolve, reject) => {
      for(let item in data) {
        switch(item) {
          case "session":
            return resolve(this.control(data[item], session))
            break
        }
      }
    })
  }
  
  control(data, session) {
    return new Promise((resolve, reject) => {
      for(let item in data) {
        switch(item) {
          case "next":
            //session.callback(data[item])
            return resolve(data[item])
            break
          case "quit":
            this.event.emit('cancel', {"_id":session._id})
            return resolve(undefined)
            break
          case "split":
            if(data.split.hasOwnProperty('name')) {
              session.event.emit('split', {cue:data.split.next, name:data.split.name})
            } else {
              session.event.emit('split', {cue:data.split.next})
            }
            return resolve(undefined)
            break
          case "join":
            session.event.emit('join', data.join)
            return resolve(undefined)
            break
          case "start":
            session.variables.review(data[item].level)
            .then(result => {
              if(!result) {
                log.error(this.name, data[item].level + " does not resolve to a proper value")
                return resolve(undefined)
              }
              data[item].level = result
              return session.variables.getDocumentByReference(data[item].player)
            })
            .then(player_list => {
              if(player_list) {
                for(let player of player_list) {
                  // only resolve once callback returned
                  // @todo what do I do when it does not return because there was an error that createSession didnt catch
                  let store_id = (session_id) => {
                    session.variables.store(session_id)
                    return resolve(undefined)
                  }
                  
                  if(data[item].name) {
                    this.event.emit('create', {level:data[item].level, player:{_id:player._id}, role:data[item].role, name:data[item].name, callback:store_id})
                  } else {
                    this.event.emit('create', {level:data[item].level, player:{_id:player._id}, role:data[item].role, callback:store_id})
                  }
                }
              } else {
                log.error(this.name, "couldn't start level " + data[item].level + ". Player " + data[item].player + " that is supposed to be assigned is not found")
                return resolve(undefined)
              }
            })
            .catch(error => {
              log.error(this.name, error)
              return resolve(undefined)
            })
            
            break
          case "cancel":
            this.event.emit('cancel', data[item])
            return resolve(undefined)
            break
          case "assign":
            session.variables.review(data.assign.session)
            .then(result => {
              let player = session.variables.getReference(data[item].player)
              if(player) {
                this.event.emit('assign', {session:{_id:result}, player:player.query, role:data.assign.role})
              } else {
                return reject("couldn't resolve player reference " + data.assign.player)
              }
              return resolve(undefined)
            })
            .catch(error => {
              log.error(this.name, error)
            })
            
            break
        }
      }
    })
  }
}

module.exports.Plaitool = SessionControl
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Modules</h3><ul><li><a href="module-ableton.html">ableton</a></li><li><a href="module-control.html">control</a></li><li><a href="module-d-pro.html">d-pro</a></li><li><a href="module-device.html">device</a></li><li><a href="module-devices.html">devices</a></li><li><a href="module-errors.html">errors</a></li><li><a href="module-file.html">file</a></li><li><a href="module-game.html">game</a></li><li><a href="module-index.html">index</a></li><li><a href="module-logic.html">logic</a></li><li><a href="module-medley.html">medley</a></li><li><a href="module-mongo.html">mongo</a></li><li><a href="module-ne.html">ne</a></li><li><a href="module-phone.html">phone</a></li><li><a href="module-session.html">session</a></li><li><a href="module-sound.html">sound</a></li><li><a href="module-telegram.html">telegram</a></li><li><a href="module-tool.html">tool</a></li><li><a href="module-tradfri.html">tradfri</a></li><li><a href="module-twilio.html">twilio</a></li><li><a href="module-variables.html">variables</a></li></ul><h3>Classes</h3><ul><li><a href="CollectionAPI.html">CollectionAPI</a></li><li><a href="Data.html">Data</a></li><li><a href="module-ableton-Liveset.html">Liveset</a></li><li><a href="module-d-pro-Show.html">Show</a></li><li><a href="module-device-Device.html">Device</a></li><li><a href="module-device-Mididevice.html">Mididevice</a></li><li><a href="module-device-OSCdevice.html">OSCdevice</a></li><li><a href="module-device-Serialdevice.html">Serialdevice</a></li><li><a href="module-device-TCPdevice.html">TCPdevice</a></li><li><a href="module-device-UDPdevice.html">UDPdevice</a></li><li><a href="module-device-Webdevice.html">Webdevice</a></li><li><a href="module-errors-DesignError.html">DesignError</a></li><li><a href="module-game-Game.html">Game</a></li><li><a href="module-logic-Condition.html">Condition</a></li><li><a href="module-logic-Listener.html">Listener</a></li><li><a href="module-medley-Log.html">Log</a></li><li><a href="module-mongo-Collection.html">Collection</a></li><li><a href="module-mongo-Database.html">Database</a></li><li><a href="module-mongo-Document.html">Document</a></li><li><a href="module-ne-Collection.html">Collection</a></li><li><a href="module-ne-Database.html">Database</a></li><li><a href="module-ne-Document.html">Document</a></li><li><a href="module-phone-Phone.html">Phone</a></li><li><a href="module-session-Session.html">Session</a></li><li><a href="module-telegram-Bot.html">Bot</a></li><li><a href="module-tool-Collection.html">Collection</a></li><li><a href="module-tool-Item.html">Item</a></li><li><a href="module-tool-Tool.html">Tool</a></li><li><a href="module-twilio-Call.html">Call</a></li><li><a href="module-twilio-CallIn.html">CallIn</a></li><li><a href="module-twilio-SmsIn.html">SmsIn</a></li><li><a href="module-twilio-Switchboard.html">Switchboard</a></li><li><a href="module-variables-Variables.html">Variables</a></li></ul><h3>Global</h3><ul><li><a href="global.html#assignIntro">assignIntro</a></li><li><a href="global.html#assignStory">assignStory</a></li><li><a href="global.html#assignTaskC">assignTaskC</a></li><li><a href="global.html#attendance">attendance</a></li><li><a href="global.html#cancelPlayerSessions">cancelPlayerSessions</a></li><li><a href="global.html#cancelSessions">cancelSessions</a></li><li><a href="global.html#checkQueue">checkQueue</a></li><li><a href="global.html#cooperation">cooperation</a></li><li><a href="global.html#getLocationText">getLocationText</a></li><li><a href="global.html#getLoginLink">getLoginLink</a></li><li><a href="global.html#getPlace">getPlace</a></li><li><a href="global.html#getReader">getReader</a></li><li><a href="global.html#jobData">jobData</a></li><li><a href="global.html#left">left</a></li><li><a href="global.html#nextJob">nextJob</a></li><li><a href="global.html#since">since</a></li><li><a href="global.html#startValues">startValues</a></li><li><a href="global.html#timestamp">timestamp</a></li><li><a href="global.html#updateQueue">updateQueue</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a> on Thu Dec 12 2019 19:18:46 GMT+0100 (CET)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
